//
//	MiscClipTextField.h -- a TextField subclass for displaying long string 
//						   values
//		Written and Copyright (c) 1995 by Balazs Pataki. 
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <appkit/TextField.h>

@interface MiscClipTextField : TextField

{
	int origAlignment;
}

+ setCellClass:classId;

- initFrame:(const NXRect *)rect;	

- setStringValue:(const char*)stringValue;
- resetStringValue:sender;

- setAlignment:(int)align;
- setClipEnabled:(BOOL)flag;
- setClipOnRight:(BOOL)flag;
- setClipperString:(const char*)aString;
- setClipDelimiters:(const char*)delimiters;

- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)event;

- (const char*)fullStringValue;
- clipper;
- delimiters;
- (BOOL) doesClipOnRight;
- (BOOL) isClipEnabled;

@end


@interface MiscClipTextField(IBStuff)
- (const char *)getInspectorClassName;
@end


@interface MiscClipTextField(Test)
- changeFont:sender;
@end
