//
//	MiscProgressBarInspector.m -- a simple view class for displaying progress
//		Written and Copyright (c) 1993 by James Heiser.  (jheiser@adobe.com)
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	


#import "MiscProgressBarInspector.h"
#import "MiscProgressView.subproj/MiscProgressBar.h"

@implementation MiscProgressBarInspector

- init
{
    char buf[MAXPATHLEN + 1];
    id bundle;
    
    [super init];
    
    bundle = [NXBundle bundleForClass:[MiscProgressBar class]];
    [bundle getPath:buf 
            forResource:"MiscProgressBarInspector" 
            ofType:"nib"];
    [NXApp loadNibFile:buf 
           owner:self 
           withNames:NO 
           fromZone:[self zone]];
    return self;
}

- ok:sender
{
	[object setTicsVisible:[theSwitch intValue]];
	[object setTicsOverBar:[theSwitch2 intValue]];
	[object setTickColor:[tickColorWell color]];
	[object setNumTicks:[tickText intValue]];
	[object setEmphasis:[emphasisText intValue]];
    return [super ok:sender];
}

- revert:sender
{
	[theSwitch setState:[object isTicsVisible]];
	[theSwitch2 setState:[object isTicsOverBar]];
	[tickColorWell setColor:[object tickColor]];
	[tickText setIntValue:[object numTicks]];
	[emphasisText setIntValue:[object emphasis]];
    return [super revert:sender];
}

- (BOOL)wantsButtons
{
    return NO;
}

@end
