//
//	MiscProgressView.h -- a simple view class for displaying progress
//		Written originally by Don Yacktman Copyright (c) 1993 by James Heiser.
//				Modified from an example in the NeXT documentation.
//				This file is maintained by James Heiser, jheiser@adobe.com.
//				Version 1.0.  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <appkit/appkit.h>

#define MISC_PROGRESS_DEFAULTSTEPSIZE 5
#define MISC_PROGRESS_MAXSIZE 100

@interface MiscProgressView:View
{
	int total, count, stepSize;
	float ratio;
	NXColor bg, fg, bd; // foreground, background, border colors
}

- initFrame:(const NXRect *)frameRect;
- renderBackground;
- renderBar;
- renderBorder;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- setStepSize:(int)value;
- (int)stepSize;
- (NXColor)backgroundColor;
- (NXColor)foregroundColor;
- (NXColor)borderColor;
- setBackgroundColor:(NXColor)color;
- setForegroundColor:(NXColor)color;
- setBorderColor:(NXColor)color;
- setRatio:(float)newRatio;
- takeIntValueFrom:sender;
- increment:sender;
- takeFloatValueFrom:sender;
- (const char *)getInspectorClassName;
- clear:sender;
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

@end
