// Copyright (C) 1995 Steve Hayman
// Use is governed by the MiscKit license

#import "MiscShellPalette.h"
#import "MiscShell.h"
#import "MiscShellInspector.h"
#import "MiscAwakeAction.h"

@implementation  MiscShellPalette
- finishInstantiate
{

    [self associateObject:aMiscShell
			type:IBObjectPboardType with:aButton];
    [self associateObject:anAwakeAction
			type:IBObjectPboardType with:anotherButton];

    return self;
}
@end


/*
 * Add some IB support stuff for MiscShell here rather than cluttering
 * up the MiscShell source itself.
 */
@implementation MiscShell(IBSupport)

- (const char *)getInspectorClassName
{
    return "MiscShellInspector";
}

-(NXImage *) getIBImage
{
    id  idBundle;
	id idImage = nil;
    char buf[MAXPATHLEN + 1];
    
	idBundle = [NXBundle bundleForClass:[MiscShellInspector class]];
	[idBundle getPath:buf forResource:"MiscShell" ofType:"tiff"];
	idImage = [[NXImage alloc] initFromFile:buf];
	return idImage;
}

@end


@implementation MiscAwakeAction(IBSupport)

-(NXImage *) getIBImage
{
    id  idBundle;
	id idImage = nil;
    char buf[MAXPATHLEN + 1];
    
	idBundle = [NXBundle bundleForClass:[MiscShellInspector class]];
	[idBundle getPath:buf forResource:"MiscAwakeAction" ofType:"tiff"];
	idImage = [[NXImage alloc] initFromFile:buf];
	return idImage;
}

@end
