//=============================================================================
//
//		Copyright (C) 1995, 1996 by Paul S. McCarthy and Eric Sunshine.
//				Written by Paul S. McCarthy and Eric Sunshine.
//							All Rights Reserved.
//
//		This notice may not be removed from this source code.
//
//		This object is included in the MiscKit by permission from the authors
//		and its use is governed by the MiscKit license, found in the file
//		"License.rtf" in the MiscKit distribution.	Please refer to that file
//		for a list of all applicable permissions and restrictions.
//		
//=============================================================================
//-----------------------------------------------------------------------------
// MiscNullView.M
//
//		View class that covers the gap in the upper left corner when a 
//		MiscTableScroll has both row and column titles turned on.
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// $Id: MiscNullView.M,v 1.2 96/01/13 23:38:37 zarnuk Exp $
// $Log:		MiscNullView.M,v $
//	Revision 1.2  96/01/13	23:38:37  zarnuk
//	Now allocates the cell from [self zone].
//	
//	Revision 1.1  95/09/27	12:21:21  zarnuk
//	Initial revision
//	
//-----------------------------------------------------------------------------
#import "MiscNullView.h"
#import "MiscBorderCell.h"

extern "Objective-C" {
#import <appkit/graphics.h>
}

@implementation MiscNullView

//-----------------------------------------------------------------------------
// - free
//-----------------------------------------------------------------------------
- free
	{
	[theCell free];
	return [super free];
	}



//-----------------------------------------------------------------------------
// - initFrame:
//-----------------------------------------------------------------------------
- initFrame:(NXRect const*)frameRect
	{
	[super initFrame:frameRect];
	[self setFlipped:YES];
	[self setOpaque:YES];
	[self setClipping:NO];
	theCell = [[MiscBorderCell allocFromZone:[self zone]] initTextCell:""];
	return self;
	}



//-----------------------------------------------------------------------------
// - drawSelf::
//-----------------------------------------------------------------------------
- drawSelf: (NXRect const*) rects : (int) nrects
	{
	[theCell drawSelf:&bounds inView:self];
	return self;
	}

@end
