//
//	MiscDimpleCell.h -- An NXBrowserCell subclass that adds a mark image so
//						a list can have an appearance similar to the IB
//						connection inspector list.
//
//		Written by David Fedchenko.  Copyright 1994 by David Fedchenko.
//				Version 1.0  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <appkit/appkit.h>

@interface MiscDimpleCell:NXBrowserCell
	{
	BOOL fMarked;
	}

+ setMarkImage:anImage;
+ markImage;
- setMarked:(BOOL)flag;
-(BOOL) marked;

- drawInside:(const NXRect *)cellFrame inView:controlView;
- highlight:(const NXRect *)cellFrame inView:aView lit:(BOOL)lit;
- drawMark:(const NXRect *)cellFrame;

@end
