//
//	MiscTeeConnectorInspector.m -- The inspector for the multiple connector
//								   object that's the inspectee.
//
//		Written by David Fedchenko.  Copyright 1994 by David Fedchenko.
//				Version 1.0  All rights reserved.
//
//		This notice may not be removed from this source code.
//
//	This object is included in the MiscKit by permission from the author
//	and its use is governed by the MiscKit license, found in the file
//	"LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
//	for a list of all applicable permissions and restrictions.
//	

#import <appkit/appkit.h>
#import <apps/InterfaceBuilder.h>
#import "MiscTee.subproj/MiscTee.h"

// Category of MiscTeeConnector that adds IB support
@interface MiscTee (ConnectionsInspector)

-(const char *) getConnectInspectorClassName;
-(NXImage *) getIBImage;

@end

// Connection inspector for the MiscTeeConnector class
@interface MiscTeeConnectorInspector:IBInspector
    {
	id	actionTitleField;
	id	outletBrowser;
	
	id	(connectorList);
	id	(idConnector);
	id	(idNonActions);
    }

- init;
- free;
- awakeFromNib;

- ok:sender;
- revert:sender;
-(BOOL) wantsButtons;
- clickOutlet:sender;

- refreshList;
-(int) findConnection;
-(int) browser:sender fillMatrix:matrix inColumn:(int)column;

- cleanClassName:(char *)sz;
- getActions:(const char *)szClassName;

@end
